﻿using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// 효과 모델
    /// </summary>
    public class EffectModel : INotifyPropertyChanged
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 속성 변경시 이벤트 - PropertyChanged

        /// <summary>
        /// 속성 변경시 이벤트
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 효과
        /// </summary>
        private Effect effect;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 효과 - Effect

        /// <summary>
        /// 효과
        /// </summary>
        public Effect Effect
        {
            get
            {
                return this.effect;
            }
            set
            {
                this.effect = value;

                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("Effect"));
            }
        }

        #endregion
    }
}